<?php

if ( ! defined( 'ABSPATH' ) ) { exit; }

 if ( ! defined( 'ABSPATH' ) ) { exit; } class FS_Api { private static $_instances = array(); private static $_options; private static $_cache; private static $_clock_diff; private $_api; private $_slug; private $_logger; private $_sdk_version; static function instance( $slug, $scope, $id, $public_key, $is_sandbox, $secret_key = false, $sdk_version = null ) { $identifier = md5( $slug . $scope . $id . $public_key . ( is_string( $secret_key ) ? $secret_key : '' ) . json_encode( $is_sandbox ) ); if ( ! isset( self::$_instances[ $identifier ] ) ) { self::_init(); self::$_instances[ $identifier ] = new FS_Api( $slug, $scope, $id, $public_key, $secret_key, $is_sandbox, $sdk_version ); } return self::$_instances[ $identifier ]; } private static function _init() { if ( isset( self::$_options ) ) { return; } if ( ! class_exists( 'Freemius_Api_WordPress' ) ) { require_once WP_FS__DIR_SDK . '/FreemiusWordPress.php'; } self::$_options = FS_Option_Manager::get_manager( WP_FS__OPTIONS_OPTION_NAME, true, true ); self::$_cache = FS_Cache_Manager::get_manager( WP_FS__API_CACHE_OPTION_NAME ); self::$_clock_diff = self::$_options->get_option( 'api_clock_diff', 0 ); Freemius_Api_WordPress::SetClockDiff( self::$_clock_diff ); if ( self::$_options->get_option( 'api_force_http', false ) ) { Freemius_Api_WordPress::SetHttp(); } } private function __construct( $slug, $scope, $id, $public_key, $secret_key, $is_sandbox, $sdk_version ) { $this->_api = new Freemius_Api_WordPress( $scope, $id, $public_key, $secret_key, $is_sandbox ); $this->_slug = $slug; $this->_sdk_version = $sdk_version; $this->_logger = FS_Logger::get_logger( WP_FS__SLUG . '_' . $slug . '_api', WP_FS__DEBUG_SDK, WP_FS__ECHO_DEBUG_SDK ); } private function _sync_clock_diff( $diff = false ) { $this->_logger->entrance(); $new_clock_diff = ( false === $diff ) ? Freemius_Api_WordPress::FindClockDiff() : $diff; if ( $new_clock_diff === self::$_clock_diff ) { return false; } self::$_clock_diff = $new_clock_diff; Freemius_Api_WordPress::SetClockDiff( self::$_clock_diff ); self::$_options->set_option( 'api_clock_diff', self::$_clock_diff, true ); return $new_clock_diff; } private function _call( $path, $method = 'GET', $params = array(), $retry = false ) { $this->_logger->entrance( $method . ':' . $path ); if ( self::is_temporary_down() ) { $result = $this->get_temporary_unavailable_error(); } else { if ( ! empty( $this->_sdk_version ) ) { if ( false === strpos( $path, 'sdk_version=' ) && ! isset( $params['sdk_version'] ) ) { $path = add_query_arg( 'sdk_version', $this->_sdk_version, $path ); } } $result = $this->_api->Api( $path, $method, $params ); if ( null !== $result && isset( $result->error ) && isset( $result->error->code ) && 'request_expired' === $result->error->code ) { if ( ! $retry ) { $diff = isset( $result->error->timestamp ) ? ( time() - strtotime( $result->error->timestamp ) ) : false; if ( false !== $this->_sync_clock_diff( $diff ) ) { return $this->_call( $path, $method, $params, true ); } } } } if ( $this->_logger->is_on() && self::is_api_error( $result ) ) { $this->_logger->api_error( $result ); } return $result; } function call( $path, $method = 'GET', $params = array() ) { return $this->_call( $path, $method, $params ); } function get_signed_url( $path ) { return $this->_api->GetSignedUrl( $path ); } function get( $path = '/', $flush = false, $expiration = WP_FS__TIME_24_HOURS_IN_SEC ) { $this->_logger->entrance( $path ); $cache_key = $this->get_cache_key( $path ); if ( WP_FS__DEV_MODE || $this->_api->IsSandbox() ) { $flush = true; } $cached_result = self::$_cache->get( $cache_key ); if ( $flush || ! self::$_cache->has_valid( $cache_key, $expiration ) ) { $result = $this->call( $path ); if ( ! is_object( $result ) || isset( $result->error ) ) { if ( is_object( $cached_result ) && ! isset( $cached_result->error ) ) { $result = $cached_result; if ( $this->_logger->is_on() ) { $this->_logger->warn( 'Fallback to cached API result: ' . var_export( $cached_result, true ) ); } } else { if ( is_object( $result ) && 404 == $result->error->http ) { $expiration /= 2; } else { return $result; } } } self::$_cache->set( $cache_key, $result, $expiration ); $cached_result = $result; } else { $this->_logger->log( 'Using cached API result.' ); } return $cached_result; } function is_cached( $path, $method = 'GET', $params = array() ) { $cache_key = $this->get_cache_key( $path, $method, $params ); return self::$_cache->has_valid( $cache_key ); } function purge_cache( $path, $method = 'GET', $params = array() ) { $this->_logger->entrance( "{$method}:{$path}" ); $cache_key = $this->get_cache_key( $path, $method, $params ); self::$_cache->purge( $cache_key ); } function update_cache_expiration( $path, $expiration = WP_FS__TIME_24_HOURS_IN_SEC, $method = 'GET', $params = array() ) { $this->_logger->entrance( "{$method}:{$path}:{$expiration}" ); $cache_key = $this->get_cache_key( $path, $method, $params ); self::$_cache->update_expiration( $cache_key, $expiration ); } private function get_cache_key( $path, $method = 'GET', $params = array() ) { $canonized = $this->_api->CanonizePath( $path ); return strtolower( $method . ':' . $canonized ) . ( ! empty( $params ) ? '#' . md5( json_encode( $params ) ) : '' ); } static function test() { self::_init(); $cache_key = 'ping_test'; $test = self::$_cache->get_valid( $cache_key, null ); if ( is_null( $test ) ) { $test = Freemius_Api_WordPress::Test(); if ( false === $test && Freemius_Api_WordPress::IsHttps() ) { Freemius_Api_WordPress::SetHttp(); self::$_options->set_option( 'api_force_http', true, true ); $test = Freemius_Api_WordPress::Test(); if ( false === $test ) { self::$_options->set_option( 'api_force_http', false, true ); } } self::$_cache->set( $cache_key, $test, WP_FS__TIME_5_MIN_IN_SEC ); } return $test; } static function is_temporary_down() { self::_init(); $test = self::$_cache->get_valid( 'ping_test', null ); return ( false === $test ); } private function get_temporary_unavailable_error() { return (object) array( 'error' => (object) array( 'type' => 'TemporaryUnavailable', 'message' => 'API is temporary unavailable, please retry in ' . ( self::$_cache->get_record_expiration( 'ping_test' ) - WP_FS__SCRIPT_START_TIME ) . ' sec.', 'code' => 'temporary_unavailable', 'http' => 503 ) ); } function ping( $unique_anonymous_id = null, $params = array() ) { $this->_logger->entrance(); if ( self::is_temporary_down() ) { return $this->get_temporary_unavailable_error(); } $pong = is_null( $unique_anonymous_id ) ? Freemius_Api_WordPress::Ping() : $this->_call( 'ping.json?' . http_build_query( array_merge( array( 'uid' => $unique_anonymous_id ), $params ) ) ); if ( $this->is_valid_ping( $pong ) ) { return $pong; } if ( self::should_try_with_http( $pong ) ) { Freemius_Api_WordPress::SetHttp(); self::$_options->set_option( 'api_force_http', true, true ); $pong = is_null( $unique_anonymous_id ) ? Freemius_Api_WordPress::Ping() : $this->_call( 'ping.json?' . http_build_query( array_merge( array( 'uid' => $unique_anonymous_id ), $params ) ) ); if ( ! $this->is_valid_ping( $pong ) ) { self::$_options->set_option( 'api_force_http', false, true ); } } return $pong; } private static function should_try_with_http( $result ) { if ( ! Freemius_Api_WordPress::IsHttps() ) { return false; } return ( ! is_object( $result ) || ! isset( $result->error ) || ! isset( $result->error->code ) || ! in_array( $result->error->code, array( 'curl_missing', 'cloudflare_ddos_protection', 'maintenance_mode', 'squid_cache_block', 'too_many_requests', ) ) ); } function is_valid_ping( $pong ) { return Freemius_Api_WordPress::Test( $pong ); } function get_url( $path = '' ) { return Freemius_Api_WordPress::GetUrl( $path, $this->_api->IsSandbox() ); } static function clear_cache() { self::_init(); self::$_cache = FS_Cache_Manager::get_manager( WP_FS__API_CACHE_OPTION_NAME ); self::$_cache->clear(); } static function is_api_error( $result ) { return ( is_object( $result ) && isset( $result->error ) ) || is_string( $result ); } static function is_api_error_object( $result ) { return ( is_object( $result ) && isset( $result->error ) && isset( $result->error->message ) ); } static function is_api_result_object( $result, $required_property = null ) { return ( is_object( $result ) && ! isset( $result->error ) && ( empty( $required_property ) || isset( $result->{$required_property} ) ) ); } static function is_api_result_entity( $result ) { return self::is_api_result_object( $result, 'id' ) && FS_Entity::is_valid_id( $result->id ); } static function get_error_code( $result ) { if ( is_object( $result ) && isset( $result->error ) && is_object( $result->error ) && ! empty( $result->error->code ) ) { return $result->error->code; } return ''; } }